/*
 * File:   CGame.cpp
 * Author: Adam Netocny
 *
 * Created on Pondelok, 2009, december 28, 17:53
 */

#include "CGame.h"
#include "CAi.h"
#include "CTable.h"
#include "COponent.h"
#include "CNetwork.h"
#include "CPlayer.h"
#include "CStack.h"

CGame::CGame(void) {
    //alokujem a nastavim atributy
    m_GridSize = 0;
    m_Table = NULL;
    m_Player = NULL;
    m_Oponent = NULL;
    m_Stack = new CStack();
    m_started = true;
}

CGame::~CGame(void) {
    //uvolnuje bloky pamate
    if (m_Table != NULL) {
        delete m_Table;
    }
    if (m_Player != NULL) {
        delete m_Player;
    }
    if (m_Oponent != NULL) {
        delete m_Oponent;
    }
    delete m_Stack;
}

//metoda zabezpecuje priechod hrou

void CGame::Start(void) {
    //vytvori menu(false ak vznikne problem pri vytvarani sietovej hry)
    if (!Menu()) return;
    //zacne hru
    //kontrola vyhry/remizy
    while (m_Table->Check() == '\0' && m_started) {
        //tah hraca
        PrintTable();
        m_Player->ReadMove();

        //Ak bola hra ukoncena
        if (!m_started)break;

        //ulozi tah do zasobniku

        int x, y;
        m_Table->GetLastChanged(x, y);
        m_Stack->Push(x, y);

        //tah oponenta
        PrintTable();
        if (!m_Oponent->MakeMove()) {
            //false je vrateny len v pripade sietovej hre pri zlyhani spojenia
            cout << "Neocakavany problem v hre, pravdepodobne nefunguje sietove prepojenie alebo druha strana pripojenie ukoncila! Ukoncujem hru...." << endl;
            return;
        }
        //ulozi tah do zasobniku
        m_Table->GetLastChanged(x, y);
        m_Stack->Push(x, y);
    }
    //kontrola vyhry
    if (m_Table->Check() == 'X') {
        PrintTable();
        cout << "Gratulujem, vyhrali ste." << endl;
    }
    if (m_Table->Check() == 'O') {
        PrintTable();
        cout << "Lutujem, vyhral oponent." << endl;
    }
    //kontrola remizy
    if (m_Table->Check() == 'R') {
        PrintTable();
        cout << "Hra skoncila remizou." << endl;
    }
}

//metoda zabezpecuje vytvorenie a navigaciu v pociatocnom menu

bool CGame::Menu(void) {
    //maximalna velkost hracieho pola
    int maxGridSize = 9;
    //Vyber typu hry
    cout << "Zvolte typ hry:" << endl;
    cout << "\t1 - Proti pocitacu" << endl;
    cout << "\t2 - Cez siet" << endl;
    int x = 0;
    while (x != 1 && x != 2) {
        char c;
        cin.get(c);
        if (c == '\n' || c == '\r') continue;
        x = c - '0';
        cin.get(c);
        if (!cin.good() || (x != 1 && x != 2) || (!(c == '\n' || c == '\r'))) {
            cout << "\t" << "Zadali ste nespravnu hodnotu! Zadavanie, prosim, opakujte." << endl;
            x = 0;
        }
        while (c != '\n' && c != '\r') {
            char c;
            cin.get(c);
            if (c == '\n' || c == '\r') break;
        }
    }
    //Pre hru proti PC
    if (x == 1) {
        m_Type = true;
        //ziska velkost hracieho pola
        cout << "Zadajte velkost hracieho pola[cislo od 3 do " << maxGridSize << "]:" << endl;
        int gridSize = 0;
        while (gridSize > maxGridSize || gridSize < 3) {
            char c;
            cin.get(c);
            if (c == '\n' || c == '\r') continue;
            gridSize = c - '0';
            cin.get(c);
            if (!cin.good() || gridSize > maxGridSize || gridSize < 3 || (!(c == '\n' || c == '\r'))) {
                if (!cin.good()) {
                    char c[200];
                    cin.getline(c, 200);
                }
                cout << "\t" << "Zadali ste nespravnu hodnotu! Zadavanie, prosim, opakujte." << endl;
                gridSize = 0;
            }
            while (c != '\n' && c != '\r') {
                char c;
                cin.get(c);
                if (c == '\n' || c == '\r') break;
            }
        }
        //alokuje zvysne potrebne objekty
        m_Table = new CTable(gridSize);
        m_GridSize = gridSize;
        m_Oponent = new CAi(m_Table);
        m_Player = new CPlayer(m_Table, this, true);
    } else {
        m_Type = false;
        // pre hru proti hracovi cez siet
        CNetwork* network;
        //vyber typu sietoveho pripojenia
        cout << "Chcete vytvorit server, alebo sa chcete pripojit? [1 - Server, 2 - Klient]" << endl;
        x = 0;
        while (x != 1 && x != 2) {
            char c;
            cin.get(c);
            if (c == '\n' || c == '\r') continue;
            x = c - '0';
            cin.get(c);
            if (!cin.good() || (x != 1 && x != 2) || (!(c == '\n' || c == '\r'))) {
                cout << "\t" << "Zadali ste nespravnu hodnotu! Zadavanie, prosim, opakujte." << endl;
                x = 0;
            }
            while (c != '\n' && c != '\r') {
                char c;
                cin.get(c);
                if (c == '\n' || c == '\r') break;
            }
        }
        //pre serverove pripojenie
        if (x == 1) {
            //ziska velkost hracieho pola
            cout << "Zadajte velkost hracieho pola[cislo od 3 do " << maxGridSize << "]:" << endl;
            int gridSize = 0;
            while (gridSize > maxGridSize || gridSize < 3) {
                char c;
                cin.get(c);
                if (c == '\n' || c == '\r') continue;
                gridSize = c - '0';
                cin.get(c);
                if (!cin.good() || gridSize > maxGridSize || gridSize < 3 || (!(c == '\n' || c == '\r'))) {
                    if (!cin.good()) {
                        char c[200];
                        cin.getline(c, 200);
                    }
                    cout << "\t" << "Zadali ste nespravnu hodnotu! Zadavanie, prosim, opakujte." << endl;
                    gridSize = 0;
                }
                while (c != '\n' && c != '\r') {
                    char c;
                    cin.get(c);
                    if (c == '\n' || c == '\r') break;
                }
            }
            //vytvory poterbne objekty
            m_Table = new CTable(gridSize);
            m_GridSize = gridSize;
            m_Player = new CPlayer(m_Table, this, false);
            //vytvori sietove rozhrannie
            char* y = new char[1];
            y[0] = '\0';
            network = new CNetwork(m_Table, y, 8191, true, this); //true pre server
        } else {
            //pre klientske pripojenie
            //ziska IP adresu(hostname)
            cout << "Zadajte ip adresu/host name servru:" << endl;
            char* host = new char[100];
            host[0] = '\0';
            while (host[0] == '\0') {
                cin.getline(host, 100);
            }
            //vytvori potrebne objekty
            m_Table = new CTable(maxGridSize);
            m_Player = new CPlayer(m_Table, this, false);
            //vytvori sietove rozhrannie
            network = new CNetwork(m_Table, host, 8191, false, this); //false pre klienta
        }
        //prepoji rozhrannia navzajom
        cout << "Pripajam..." << endl;
        if (!network->Connect(m_GridSize)) {
            cout << "Nepodarilo sa vytvorit pripojenie alebo druha strana pripojenie ukoncila! Hra sa automaticky ukonci..." << endl;
            m_Oponent = network;
            return false;
        }
        //ulozi rozhrannie do oponenta
        m_Oponent = network;
    }
    return true;
}

//Metoda vykresluje hracie pole na standardny vystup

void CGame::PrintTable(void) {
    //vykresli rovnu ciaru
    cout << setfill('-') << setw(30) << "" << endl;
    //prechadza tabulku
    for (int i = -1; i <= m_GridSize; i++) {
        //vykresli rovnu ciaru pre kazdy riadok
        cout << setfill('-') << setw(4 * m_GridSize + 2 + ((m_GridSize > 9) ? 1 : 0)) << "" << endl;
        //vykresli popisny riadok (A-X)
        if (i == -1 || i == m_GridSize) {
            cout << " ";
            if (m_GridSize > 9) {
                cout << " ";
            }
            char c = 'A';
            for (int j = 0; j < m_GridSize; j++) {
                cout << "| ";
                cout << c << " ";
                c++;
            }
            cout << "|" << endl;
        } else {
            //vykresli normalny riadok
            if (m_GridSize > 9 && i < 9) {
                cout << " ";
            }
            cout << i + 1;
            for (int j = 0; j < m_GridSize; j++) {
                cout << "| ";
                char c;
                m_Table->GetChar(i, j, c);
                if (c == '\0')
                    cout << "  ";
                else
                    cout << c << " ";
            }
            cout << "|" << endl;
        }
    }
    //vykresli poslednu ciaru
    cout << setfill('-') << setw(4 * m_GridSize + 2 + ((m_GridSize > 9) ? 1 : 0)) << "" << endl;
}

//Metoda zabezpecuje krok spat v hre

bool CGame::Back(void) {
    //Ak to oponent dovoluje
    if (m_Oponent == NULL)return false;
    if (!m_Oponent->AllowsBack()) return false;
    //Precistime dane dve polia
    int x, y;
    if (m_Stack->Pop(x, y))
        m_Table->ClearChar(x, y);
    if (m_Stack->Pop(x, y))
        m_Table->ClearChar(x, y);
    //Vykresli hracie pole
    PrintTable();
    return true;
}

//Ukonci predcasne hru(len pri sietovej hre

void CGame::StopGame(void) {
    if (!m_Type) {
        m_started = false;
        ((CNetwork*) m_Oponent)->CloseConnection();
    }
}