/* 
 * File:   CGame.h
 * Author: Adam Netocny
 *
 * Created on Pondelok, 2009, december 28, 17:53
 */

#ifndef __CGame__
#define __CGame__

#include "CPlayer.h"
#include "CAi.h"
#include "CNetwork.h"
#include "COponent.h"
#include "CStack.h"
#include <iostream>
#include <iomanip>
#include <stdlib.h>

using namespace std;

//Engine hry, spaja rozhrannie a samotnu logiku
class CGame {
public:
    //Konstruktor, vytvori potrebne objekty
    CGame(void);
    //Destruktor, volni pamat
    ~CGame(void);

    //Volana metodou main, zahaji hru(menu+hra)
    void Start(void);
    //Vrati o krok spat ak to oponent dovoluje
    bool Back(void);

    //Stop Game
    void StopGame(void);
protected:
    //odkaz na hracie pole
    CTable* m_Table;
    //odkaz na hraca
    CPlayer* m_Player;
    //odkaz na oponenta
    COponent* m_Oponent;
    //odkaz na zasobnik krokov
    CStack* m_Stack;
    //udaj urcujuci velkost hracieho pola
    int m_GridSize;
    //Priznak ci ma hra pokracovat
    bool m_started;
    //Typ hry
    bool m_Type;

    //vykresli hracie pole na standardny vystup
    void PrintTable(void);
    //vykresli a naviguje uzivatela cez menu
    bool Menu(void);
};

#endif /* __CGame__ */
