/* 
 * File:   CNetwork.h
 * Author: Adam Netocny
 *
 * Created on Pondelok, 2009, december 28, 17:53
 */

#ifndef __CNetwork__
#define __CNetwork__

#include "COponent.h"

class CGame;

//Trieda implementuje sietove rozhrannie

class CNetwork : public COponent {
public:
    //Konstruktor, inicializuje objekt
    CNetwork(CTable* table, char* host, int port, bool server, CGame* game);
    //Destruktor, uzavrie spojenie
    ~CNetwork(void);

    //Zabezpeci jeden tah
    bool MakeMove(void);

    //Vytvori spojenie medzi dvoma hramy
    bool Connect(int & gridSize);

    //Odosle ukoncenie
    void CloseConnection(void);
protected:
    //Adresa servru
    char* m_Host;
    //Port servru
    int m_Port;
    //Identifikator typu pripojenie(true server, false klient)
    bool m_Server;
    //Identifikator soketu
    int c_sockfd;
    //Odkaz na hru
    CGame* m_game;
};

#endif /* __CNetwork__ */
