/*
 * File:   CPlayer.cpp
 * Author: Adam Netocny
 *
 * Created on Pondelok, 2009, december 28, 17:48
 */

#include "CPlayer.h"
#include "CGame.h"
#include <iostream>
#include <stdlib.h>

using namespace std;

//Kostruktor, nastavi odkazy

CPlayer::CPlayer(CTable* table, CGame* game, bool gameType) {
    m_Table = table;
    m_Game = game;
    m_GameType = gameType;
}

//Destruktor, nema co uvolnit

CPlayer::~CPlayer(void) {
}

//Metoda pre nacitanie tahu od uzivatela

void CPlayer::ReadMove(void) {
    if (m_GameType) {
        cout << "Zadajte koordinaty bodu, ktory chcete oznacit(napr. A1), alebo 'back' pre tah spat:" << endl;
    } else {
        cout << "Zadajte koordinaty bodu, ktory chcete oznacit(napr. A1), alebo 'close' pre ukoncenie spojenia a hry:" << endl;
    }
    //Nacitava, kym nenacita spravne koordinaty
    while (true) {
        //nacita jeden riadok, resp najblizsich 10 znakov
        char* koor = new char[10];
        koor[0] = '\0';
        while (koor[0] == '\0') {
            cin.getline(koor, 10);
        }
        //ziska dlzku
        int len = 0;
        for (int i = 0; i < 10; i++) {
            if (koor[i] == '\0') {
                len = i + 1;
                break;
            }
        }
        // ak je nulovy
        if (koor[0] == '\0') {
            delete[] koor;
            continue;
        }

        //ak nacita 'back'
        if (koor[0] == 'b' && koor[1] == 'a' && koor[2] == 'c' && koor[3] == 'k' && koor[4] == '\0' && m_GameType) {
            if (!m_Game->Back()) {
                cout << "Pre dany typ hry nie je navrat o krok spat podporovany." << endl;
            } else {
                cout << "Zadajte koordinaty bodu, ktory chcete oznacit(napr. A1) alebo 'back' pre tah spat:" << endl;
            }
            delete[] koor;
            continue;
        }

        //ak nacita 'back'
        if (koor[0] == 'c' && koor[1] == 'l' && koor[2] == 'o' && koor[3] == 's' && koor[4] == 'e' && koor[5] == '\0' && !m_GameType) {
            cout << "Naozaj chcete hru ukoncti? [Y/N]" << endl;
            delete[] koor;
            char* koor = new char[2];
            koor[0] = '\0';
            while (koor[0] == '\0' || !((koor[0] == 'Y' || koor[0] == 'N' || koor[0] == 'y' || koor[0] == 'n') && koor[1] == '\0')) {
                cin.getline(koor, 2);
            }
            if (koor[0] == 'Y' || koor[0] == 'y') {
                m_Game->StopGame();

                delete[] koor;
                break;
            } else {
                cout << "Zadajte koordinaty bodu, ktory chcete oznacit(napr. A1), alebo 'close' pre ukoncenie spojenia a hry:" << endl;
                delete[] koor;
                continue;
            }
        }

        //ak nenacital spravnu dlzku
        if (len != 3) {
            cout << "Nespravne zadane koordinaty! Volbu opakujte, prosim." << endl;
            delete[] koor;
            continue;
        }

        //zistuje spravnost koordinaty zlozenej z pismen
        if ((koor[0] < 'A' || koor[0] >= 'A' + m_Table->GetSize()) && (koor[0] < 'a' || koor[0] >= 'a' + m_Table->GetSize())) {
            cout << "Nespravne zadane koordinaty! Volbu opakujte, prosim." << endl;
            delete[] koor;
            continue;
        }

        //zistuje spravnost koordinaty zlozenej z cisel
        if (koor[1] < '1' || koor[1] >= '1' + m_Table->GetSize()) {
            cout << "Nespravne zadane koordinaty! Volbu opakujte, prosim." << endl;
            delete[] koor;
            continue;
        }

        //ziska realne koordinaty
        int x, y;
        if (koor[0] >= 'A' && koor[0] < 'A' + m_Table->GetSize())
            x = (int) (koor[0] - 'A');
        else
            x = (int) (koor[0] - 'a');
        y = (int) (koor[1] - '1');
        //kontrola pola
        char c;
        if (!m_Table->GetChar(y, x, c)) {
            //nespravne zadane
            cout << "Nespravne zadane koordinaty! Volbu opakujte, prosim." << endl;
            delete[] koor;
            continue;
        }

        //Obsadene pole
        if (c != '\0') {
            cout << "Pole je uz obsadene! Volbu opakujte, prosim." << endl;
            delete[] koor;
            continue;
        }

        //zapis a uvolnenie zdrojov
        m_Table->SetChar(y, x, 'X');
        delete[] koor;
        break;
    }
}
