/*
 * File:   CStack.cpp
 * Author: Adam Netocny
 *
 * Created on January 6, 2010, 3:27 PM
 */

#include "CStack.h"
#include <stdlib.h>

//Konstruktor, inicializuje odkaz v hlave

CStack::CStack(void) {
    head = NULL;
}

//destruktor, uvolnuje zdroje

CStack::~CStack(void) {
    delete head;
}

// prida prvok

void CStack::Push(int x, int y) {
    //Ak je hlava prazdna
    if (head == NULL) {
        head = new CStack::TNode(x, y, NULL);
    } else {
        //ak hlava prazdna nie je
        head = new CStack::TNode(x, y, head);
    }
}

//Odobere prvok

bool CStack::Pop(int& x, int& y) {
    //Ak je hlava NULL nema zmysel pokracovat
    if (head == NULL) return true;
    //Odoberie prvok a zaznamena ulozene hodnoty
    CStack::TNode* node = head;
    head = head->GetNext();
    x = node->GetX();
    y = node->GetY();
    //uvolni zdroje
    node->SetNext(NULL);
    delete node;
    return true;
}

//Konstruktor, inicializuje hodnoty prvku

CStack::TNode::TNode(int x, int y, CStack::TNode* next) {
    this->x = x;
    this->y = y;
    this->next = next;
}

//Destruktor, uvolni zdroje

CStack::TNode::~TNode(void) {
    if (next != NULL) {
        delete next;
    }
}

//Vrati hodnotu X

int CStack::TNode::GetX(void) {
    return x;
}

//Vrati hodnotu Y

int CStack::TNode::GetY(void) {
    return y;
}

//Vrati odkaz na naslednika

CStack::TNode* CStack::TNode::GetNext(void) {
    return next;
}

//Nastavi odkaz na naslednika

void CStack::TNode::SetNext(TNode* next) {
    this->next = next;
}
