/* 
 * File:   CStack.h
 * Author: Adam Netocny
 *
 * Created on January 6, 2010, 3:27 PM
 */

#ifndef __CSTACK__
#define	__CSTACK__

//Zasobnik pre hkladanie pozici v hre

class CStack {
public:
    //Konstruktor, vytvori zasobnik
    CStack(void);
    //Destruktor, uvolni zdroje
    ~CStack(void);

    //Metoda pre pridanie prvku do zasobnika
    void Push(int x, int y);
    //Metoda na odstranenie prvku zo zasobnika
    bool Pop(int &x, int &y);

protected:

    // Trieda pre ukladanie prvkov, vytvara vnutornu strukturu zasobnika

    class TNode {
    public:
        //Konstruktor, vytvori prvok
        TNode(int x, int y, TNode* next);
        //Destruktor, uvolni zdroje
        ~TNode(void);

        //Vrati hodnotu X ulozenu v prvku
        int GetX(void);
        //Vrati hodnotu Y ulozenu v prvku
        int GetY(void);
        //Vrati naslednika prvku
        TNode* GetNext(void);
        //Nastavi naslednika prvku
        void SetNext(TNode* next);

    protected:
        //ulozene hodnoty X a Y
        int x, y;
        //Odkaz na naslednika
        TNode* next;
    };

    //Hlava spojoveho zonamu zasobniku
    TNode* head;
};

#endif /* __CSTACK__ */
