/* 
 * File:   CTable.h
 * Author: Adam Netocny
 *
 * Created on Pondelok, 2009, december 28, 17:49
 */

#ifndef __CTable__
#define __CTable__

//Trieda hracieho pola, zdruzuje metody pre jednoduchu udrzbu a pristup k polu

class CTable {
public:
    //Konstruktor, alokuje zdroje
    CTable(int gridSize);
    //Destruktor, uvolnuje zdroje
    ~CTable(void);

    //Nastavi hodnotu na danych suradniciach
    bool SetChar(int x, int y, char val);
    //Ziska hodnotu na danych suradniciach
    bool GetChar(int x, int y, char & val);
    //Znuluje hodnotu na danych suradniciach
    void ClearChar(int x, int y);

    //Nastavi velkost pola
    void SetSize(int gridSize);
    //Vrati velkost pola
    int GetSize(void);

    //Ziska hodnotu posledne zmenenych suradnic
    void GetLastChanged(int & x, int & y);

    //Kontroluje ci jeden z hracou vyhral alebo vznikla remiza
    char Check(void);
    
protected:
    //velkost logicka
    int m_Size;
    //velkost skutocna
    int m_RealSize;
    //dvojrozmerne pole
    char** m_Array;
    //posledne zmenene
    int m_LastChanged[2];
};

#endif /* __CTable__ */
